{smcl}
{* *! version 1.0.0  21jan2008}{...}
{cmd:help lowess_ties_optim} 
{hline}

{title:Title}

{p2colset 5 15 22 2}{...}
{p2col :{hi:lowess_ties_optim} {hline 2}} Lowess smoothing with an Optimization step{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}
{cmd: lowess_ties_optim} {depvar} {varname} {ifin}  {cmd :,} {it:options}

{synoptset 27 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Main}
{synopt : [{opt f:raction}(#)]} proportion of points used to compute each fitted value ; default 2/3 {p_end}
{synopt : [{opt s:tore}({varlist})]} variable name for calculation/plotting points ; variable name for fitted points {p_end}

{syntab:Optimization}
{synopt : [{opt iter:ations}(#)]} maximum number of iterations performed in robust fit {p_end}
{synopt : [{opt del:ta}(#)]} threshold for giving independent variable values the same ; fitted value (default 1/100 * range ind.) {p_end} 
{synoptline}
{p2colreset}{...}
{p 4 6 2}



{title:Description}

{pstd}

Generates lowess smoothed estimates of the first variable using the second.
Uses tricubic weighting.  If {it:iterations} > 0, further weighted fits are done with the product 
of the weights from the proximity of the independent variable values and case weights derived 
from the residuals on the previous iteration. Stores the results in the storage variables.

{title:Examples}

. {stata "sysuse auto"}

. {stata reg mpg weight}

. {stata gen gx = .}

. {stata gen gy = .}

. {stata lowess_ties_optim mpg weight, f(.9) iterations(10) store(gy gx)}

. {stata twoway scatter gy gx}

