{smcl}
{* *! version 1.0.0  21jan2008}{...}
{cmd:help mboxcox} 
{hline}

{title:Title}

{p2colset 5 20 22 2}{...}
{p2col:{hi:mboxcox}{hline 2}}Multivariate Box Cox{p_end}
{p2colreset}{...}

{title:Syntax}

{p 8 16 2}
{cmd: mboxcox} {varlist} {ifin} [{cmd :,} {it:options}]

{synoptset 27 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is {cmd:level(95)}{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}

{title:Description}

{pstd}

For positive {varlist}, {cmd:mboxcox} finds the optimal multivariate box cox transformation. 
                      
{cmd:mboxcox} uses maximum likelihood to estimate the vector-valued parameter that transforms 
{varlist} to multivariate normality.  The data is transformed by applying a modified scaled power 
transformation to each variable in {varlist} using the matching powers in the estimated parameter 
vector.

{title:Options}

{dlgtab:Reporting}

{phang}
{opt level(#)}; see {helpb estimation options##level():[R] estimation options}.

{title:Examples}

. {stata "sysuse auto"}

. {stata mboxcox mpg weight gear_ratio}

{title:Saved results}

{pstd}
{cmd:mboxcox} saves the following in {cmd:e()}:

{synoptset 25 tabbed}{...}
{p2col 5 25 29 2: Scalars}{p_end}
{synopt:{cmd:e(ll_0)}}log-likelihood, all parameters = 0{p_end}
{synopt:{cmd:e(ll_1)}}log-likelihood, all parameters = 1{p_end}
{synopt:{cmd:e(ll_n1)}}log-likelihood, all parameters = -1{p_end}
{synopt:{cmd:e(lrt_0)}}likelihood ratio test statistic, all parameters = 0{p_end}
{synopt:{cmd:e(lrt_1)}}likelihood ratio test statistic, all parameters = 1{p_end}
{synopt:{cmd:e(lrt_n1)}}likelihood ratio test statistic, all parameters = -1{p_end}

{p2col 5 25 29 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}power transformation estimate vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}
{p2colreset}{...}
