{smcl}
{* *! version 1.0.0  31dec2007}{...}
{cmd:help rlcipi} 
{hline}

{title:Title}

{p2colset 5 15 22 2}{...}
{p2col :{hi:rlcipi} {hline 2}}SLR Prediction and Regression Line Estimation{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}
{cmd: rlcipi} {cmd :,} {it:options}

{synoptset 27 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Main}
{synopt : [{opt pred:ict}]} give prediction intervals {p_end}
{synopt : {opt arg:uments}{bf}({it}{help numlist} min=1{bf}){sf}}  predictor values {p_end}

{syntab:Options}
{synopt : [{opt l:evel(#)}]} set confidence level; default is {bf} level(95) {sf} {p_end}
{synopt : {opt len:gth(#)}} set length of displayed results {p_end}
{synopt : {opt prec:ision(#)}} set decimal places for displayed results {p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}


{title:Description}

{pstd}
For a simple linear regression model (fit using {helpb regress}), {cmd:rlcipi} produces predictions and prediction intervals for the specified predictor values.  If {opt pred:ict} is not specified, then {cmd: rlcipi} gives estimates and confidence intervals for the regression lines under the specified predictor values. 


{title:Options}

{dlgtab:Main}

{phang}
{opt pred:ict}  specifies that predictions and prediction intervals should be calculated and displayed.

{phang}
{opt arg:uments}{bf}({it}{help numlist} min=1{bf}){sf}  specifies predictor values to be used in estimation or prediction.

{dlgtab:Options}

{phang}
{opt l:evel(#)} specifies confidence level, as a percentage, for confidence intervals.  the default is {cmd:level(95)} or as set by {helpb set level}.

{phang}
{opt len:gth(#)} specifies the number of digits of reported results.

{phang}
{opt prec:ision(#)} specifies the number of decimal places in reported results.


{title:Examples}

. {stata "sysuse auto"}

. {stata reg price mpg}

. {stata rlcipi , pred arg(10 12 20) len(7) prec(2)}

. {stata rlcipi , arg(10 12 20) len(7) prec(2)}


{title:Saved results}

{pstd}
{cmd:rlcipi} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:r(result)}} Four column matrix with one row per argument.  Stores predictor, prediction (estimation), and lower and upper bounds of interval.{p_end}
{p2colreset}{...}
